import { defineComponent as S, shallowRef as D, computed as b, onMounted as p, createVNode as h, reactive as _, onBeforeUnmount as q, watch as X, mergeProps as T, ref as J, isVNode as K } from "vue";
function C() {
  return typeof window < "u" && "IntersectionObserver" in window && "isIntersecting" in window.IntersectionObserverEntry.prototype;
}
const E = {}, Q = (e) => {
  e.forEach((t) => {
    t.isIntersecting && t.target.onVisible();
  });
}, ee = (e) => (E[e] = E[e] || new IntersectionObserver(Q, {
  rootMargin: e + "px"
}), E[e]), $ = () => typeof window > "u" ? 0 : window.scrollX || window.pageXOffset, A = () => typeof window > "u" ? 0 : window.scrollY || window.pageYOffset, H = /* @__PURE__ */ S({
  name: "PlaceholderWithoutTracking",
  props: {
    scrollPosition: {
      type: Object,
      default: null
    },
    useIntersectionObserver: {
      type: Boolean,
      default: !0
    },
    threshold: {
      type: Number,
      default: 300
    },
    onVisible: {
      type: Function,
      default: () => {
      }
    },
    height: {
      type: Number,
      default: 0
    },
    width: {
      type: Number,
      default: 0
    },
    placeholder: {
      type: Object,
      default: () => {
      }
    }
  },
  setup(e) {
    const t = D(), n = b(() => !e.scrollPosition && e.useIntersectionObserver && C()), a = b(() => n.value ? ee(e.threshold) : null);
    function o(i = e.scrollPosition) {
      const r = t.value.getBoundingClientRect(), s = t.value.style, f = {
        left: parseInt(s.getPropertyValue("margin-left"), 10) || 0,
        top: parseInt(s.getPropertyValue("margin-top"), 10) || 0
      };
      return {
        bottom: i.y + r.bottom + f.top,
        left: i.x + r.left + f.left,
        right: i.x + r.right + f.left,
        top: i.y + r.top + f.top
      };
    }
    function c() {
      if (typeof window > "u" || t.value)
        return !1;
      const i = o(e.scrollPosition), r = {
        bottom: e.scrollPosition.y + window.innerHeight,
        left: e.scrollPosition.x,
        right: e.scrollPosition.x + window.innerWidth,
        top: e.scrollPosition.y
      };
      return r.top - e.threshold <= i.bottom && r.bottom + e.threshold >= i.top && r.left - e.threshold <= i.right && r.right + e.threshold >= i.left;
    }
    function d() {
      var i;
      c() && ((i = e.onVisible) == null || i.call(e));
    }
    p(() => {
      a.value && t.value && (t.value.onVisible = e.onVisible, a.value.observe(t.value)), n.value || d == null || d();
    });
    const l = b(() => ({
      display: "inline-block",
      height: `${e.height}px`,
      width: `${e.width}px`
    }));
    return () => h("span", {
      ref: t,
      style: l.value
    }, [e.placeholder]);
  }
});
var te = typeof global == "object" && global && global.Object === Object && global;
const ne = te;
var re = typeof self == "object" && self && self.Object === Object && self, le = ne || re || Function("return this")();
const U = le;
var ie = U.Symbol;
const I = ie;
var Y = Object.prototype, oe = Y.hasOwnProperty, ae = Y.toString, O = I ? I.toStringTag : void 0;
function ue(e) {
  var t = oe.call(e, O), n = e[O];
  try {
    e[O] = void 0;
    var a = !0;
  } catch {
  }
  var o = ae.call(e);
  return a && (t ? e[O] = n : delete e[O]), o;
}
var de = Object.prototype, ce = de.toString;
function fe(e) {
  return ce.call(e);
}
var se = "[object Null]", ye = "[object Undefined]", F = I ? I.toStringTag : void 0;
function be(e) {
  return e == null ? e === void 0 ? ye : se : F && F in Object(e) ? ue(e) : fe(e);
}
function he(e) {
  return e != null && typeof e == "object";
}
var ge = "[object Symbol]";
function me(e) {
  return typeof e == "symbol" || he(e) && be(e) == ge;
}
var ve = /\s/;
function we(e) {
  for (var t = e.length; t-- && ve.test(e.charAt(t)); )
    ;
  return t;
}
var Oe = /^\s+/;
function Se(e) {
  return e && e.slice(0, we(e) + 1).replace(Oe, "");
}
function L(e) {
  var t = typeof e;
  return e != null && (t == "object" || t == "function");
}
var R = 0 / 0, Pe = /^[-+]0x[0-9a-f]+$/i, Te = /^0b[01]+$/i, Ie = /^0o[0-7]+$/i, Le = parseInt;
function z(e) {
  if (typeof e == "number")
    return e;
  if (me(e))
    return R;
  if (L(e)) {
    var t = typeof e.valueOf == "function" ? e.valueOf() : e;
    e = L(t) ? t + "" : t;
  }
  if (typeof e != "string")
    return e === 0 ? e : +e;
  e = Se(e);
  var n = Te.test(e);
  return n || Ie.test(e) ? Le(e.slice(2), n ? 2 : 8) : Pe.test(e) ? R : +e;
}
var je = function() {
  return U.Date.now();
};
const B = je;
var Ne = "Expected a function", xe = Math.max, Ee = Math.min;
function G(e, t, n) {
  var a, o, c, d, l, i, r = 0, s = !1, f = !1, v = !0;
  if (typeof e != "function")
    throw new TypeError(Ne);
  t = z(t) || 0, L(n) && (s = !!n.leading, f = "maxWait" in n, c = f ? xe(z(n.maxWait) || 0, t) : c, v = "trailing" in n ? !!n.trailing : v);
  function g(u) {
    var y = a, m = o;
    return a = o = void 0, r = u, d = e.apply(m, y), d;
  }
  function k(u) {
    return r = u, l = setTimeout(w, t), s ? g(u) : d;
  }
  function V(u) {
    var y = u - i, m = u - r, x = t - y;
    return f ? Ee(x, c - m) : x;
  }
  function j(u) {
    var y = u - i, m = u - r;
    return i === void 0 || y >= t || y < 0 || f && m >= c;
  }
  function w() {
    var u = B();
    if (j(u))
      return N(u);
    l = setTimeout(w, V(u));
  }
  function N(u) {
    return l = void 0, v && a ? g(u) : (a = o = void 0, d);
  }
  function M() {
    l !== void 0 && clearTimeout(l), r = 0, a = i = o = l = void 0;
  }
  function W() {
    return l === void 0 ? d : N(B());
  }
  function P() {
    var u = B(), y = j(u);
    if (a = arguments, o = this, i = u, y) {
      if (l === void 0)
        return k(i);
      if (f)
        return clearTimeout(l), l = setTimeout(w, t), g(i);
    }
    return l === void 0 && (l = setTimeout(w, t)), d;
  }
  return P.cancel = M, P.flush = W, P;
}
var Be = "Expected a function";
function Ce(e, t, n) {
  var a = !0, o = !0;
  if (typeof e != "function")
    throw new TypeError(Be);
  return L(n) && (a = "leading" in n ? !!n.leading : a, o = "trailing" in n ? !!n.trailing : o), G(e, t, {
    leading: a,
    maxWait: t,
    trailing: o
  });
}
const ke = (e) => {
  const t = getComputedStyle(e, null);
  return t.getPropertyValue("overflow") + t.getPropertyValue("overflow-y") + t.getPropertyValue("overflow-x");
}, Ve = (e) => {
  if (!(e instanceof HTMLElement))
    return window;
  let t = e;
  for (; t && t instanceof HTMLElement; ) {
    if (/(scroll|auto)/.test(ke(t)))
      return t;
    t = t.parentNode;
  }
  return window;
}, Me = (e) => /* @__PURE__ */ S({
  name: "ScrollAwareComponent",
  props: {
    scrollPosition: {
      type: Object,
      default: null
    },
    useIntersectionObserver: {
      type: Boolean,
      default: !0
    },
    threshold: {
      type: Number,
      default: 300
    },
    onVisible: {
      type: Function,
      default: () => {
      }
    },
    height: {
      type: Number,
      default: 0
    },
    width: {
      type: Number,
      default: 0
    },
    delayMethod: {
      type: String,
      default: "debounce"
    },
    delayTime: {
      type: Number,
      default: 300
    },
    placeholder: {
      type: Object,
      default: () => {
      }
    }
  },
  setup(n, {
    attrs: a
  }) {
    const o = b(() => n.useIntersectionObserver && C()), c = D(null), d = _({
      x: $(),
      y: A()
    });
    if (!o)
      return null;
    function l() {
      o || (d.x = $(), d.y = A());
    }
    const i = b(() => Ve(c.value));
    function r() {
      typeof window > "u" || o || (i.value.addEventListener("scroll", l), window.addEventListener("resize", l), i.value !== document.body && window.addEventListener("scroll", l));
    }
    function s() {
      typeof window > "u" || o || (i.value.removeEventListener("scroll", l), window.removeEventListener("resize", l), i.value !== document.body && window.removeEventListener("scroll", l));
    }
    p(() => {
      r();
    }), q(() => {
      s();
    }), X(i, (v, g) => {
      g && s(), r();
    });
    const f = n.delayMethod === "debounce" ? G(l, n.delayTime) : Ce(l, n.delayTime);
    return () => h(e, T(n, a, {
      scrollPosition: d,
      ref: c,
      onChangeScroll: f
    }), null);
  }
}), We = /* @__PURE__ */ S({
  name: "PlaceholderWithTracking",
  props: {
    scrollPosition: {
      type: Object,
      default: null
    },
    useIntersectionObserver: {
      type: Boolean,
      default: !0
    },
    threshold: {
      type: Number,
      default: 300
    },
    onVisible: {
      type: Function,
      default: () => {
      }
    },
    height: {
      type: Number,
      default: 0
    },
    width: {
      type: Number,
      default: 0
    },
    placeholder: {
      type: Object,
      default: () => {
      }
    }
  },
  setup(e, {
    attrs: t
  }) {
    return () => h(H, T(e, t), null);
  }
}), $e = Me(We), Ae = /* @__PURE__ */ S({
  compatConfig: {
    MODE: 3
  },
  name: "LazyLoadComponent",
  inheritAttrs: !1,
  props: {
    afterLoad: {
      type: Function,
      default: () => {
      }
    },
    beforeLoad: {
      type: Function,
      default: () => {
      }
    },
    scrollPosition: {
      type: Object,
      default: null
    },
    visibleByDefault: {
      type: Boolean,
      default: !1
    },
    height: {
      type: Number,
      default: 0
    },
    width: {
      type: Number,
      default: 0
    },
    useIntersectionObserver: {
      type: Boolean,
      default: !0
    },
    threshold: {
      type: Number,
      default: 300
    },
    style: {
      type: Object,
      default: () => {
      }
    },
    class: {
      type: String,
      default: ""
    },
    delayMethod: {
      type: String,
      default: "throttle"
    },
    delayTime: {
      type: Number,
      default: 300
    },
    placeholder: {
      type: Object,
      default: () => {
      }
    }
  },
  setup(e, {
    slots: t
  }) {
    var c, d;
    const n = _({
      visible: e.visibleByDefault ?? !1,
      loaded: !1,
      error: !1
    }), a = b(() => !!(e.scrollPosition && Number.isFinite(e.scrollPosition.x) && e.scrollPosition.x >= 0 && Number.isFinite(e.scrollPosition.y) && e.scrollPosition.y >= 0));
    X(n, (l, i) => {
      var r;
      l.visible !== (i == null ? void 0 : i.visible) && ((r = e.afterLoad) == null || r.call(e));
    }, {
      immediate: !0
    });
    const o = () => {
      var l;
      n.visible = !0, (l = e.afterLoad) == null || l.call(e);
    };
    return e.visibleByDefault && ((c = e.beforeLoad) == null || c.call(e), (d = e.afterLoad) == null || d.call(e)), () => {
      var l;
      return n.visible ? (l = t.default) == null ? void 0 : l.call(t) : a || e.useIntersectionObserver && C() ? h(H, {
        height: e.height,
        onVisible: o,
        placeholder: e.placeholder,
        scrollPosition: e.scrollPosition,
        threshold: e.threshold,
        useIntersectionObserver: e.useIntersectionObserver,
        width: e.width
      }, null) : h($e, {
        height: e.height,
        onVisible: o,
        placeholder: e.placeholder,
        scrollPosition: e.scrollPosition,
        threshold: e.threshold,
        useIntersectionObserver: e.useIntersectionObserver,
        width: e.width
      }, null);
    };
  }
});
function Fe(e) {
  return typeof e == "function" || Object.prototype.toString.call(e) === "[object Object]" && !K(e);
}
const ze = /* @__PURE__ */ S({
  name: "LazyLoadImage",
  compatConfig: {
    MODE: 3
  },
  inheritAttrs: !1,
  props: {
    afterLoad: {
      type: Function,
      default: () => {
      }
    },
    beforeLoad: {
      type: Function,
      default: () => {
      }
    },
    scrollPosition: {
      type: Object,
      default: null
    },
    visibleByDefault: {
      type: Boolean,
      default: !1
    },
    height: {
      type: Number,
      default: 0
    },
    width: {
      type: Number,
      default: 0
    },
    useIntersectionObserver: {
      type: Boolean,
      default: !0
    },
    threshold: {
      type: Number,
      default: 300
    },
    placeholderSrc: {
      type: String,
      default: ""
    },
    effect: {
      type: String,
      default: ""
    },
    loadedClassName: {
      type: String,
      default: ""
    },
    wrapperClassName: {
      type: String,
      default: ""
    },
    wrapperProps: {
      type: Object,
      default: () => {
      }
    },
    delayTime: {
      type: Number,
      default: 300
    },
    delayMethod: {
      type: String,
      default: "debounce"
    },
    placeholder: {
      type: Object,
      default: null
    },
    class: {
      type: String,
      default: ""
    },
    style: {
      type: Object,
      default: () => {
      }
    }
  },
  setup(e, {
    attrs: t
  }) {
    const n = J(!1);
    function a() {
      return n.value ? null : () => {
        var r;
        (r = e.afterLoad) == null || r.call(e), n.value = !0;
      };
    }
    function o() {
      const r = b(() => {
        const {
          class: s,
          afterLoad: f,
          beforeLoad: v,
          delayMethod: g,
          delayTime: k,
          effect: V,
          placeholder: j,
          placeholderSrc: w,
          scrollPosition: N,
          threshold: M,
          useIntersectionObserver: W,
          visibleByDefault: P,
          wrapperClassName: u,
          wrapperProps: y,
          style: m,
          loadedClassName: x,
          ...Z
        } = e;
        return Z;
      });
      return h("img", T({
        onLoad: a()
      }, r.value, t), null);
    }
    function c() {
      let r;
      return h(Ae, {
        beforeLoad: e.beforeLoad,
        class: e.class,
        delayMethod: e.delayMethod,
        delayTime: e.delayTime,
        height: e.height,
        placeholder: e.placeholder,
        scrollPosition: e.scrollPosition,
        style: e.style,
        threshold: e.threshold,
        useIntersectionObserver: e.useIntersectionObserver,
        visibleByDefault: e.visibleByDefault,
        width: e.width
      }, Fe(r = o()) ? r : {
        default: () => [r]
      });
    }
    const d = b(() => n.value ? " lazy-load-image-loaded" : ""), l = b(() => n.value || !e.placeholderSrc ? {} : {
      backgroundImage: `url(${e.placeholderSrc})`,
      backgroundSize: "100% 100%"
    });
    function i(r) {
      return h("span", T({
        class: e.wrapperClassName + " lazy-load-image-background " + e.effect + d.value,
        style: {
          ...l.value,
          color: "transparent",
          display: "inline-block",
          height: e.height + "px",
          width: e.width + "px"
        }
      }, e.wrapperProps), [r]);
    }
    return () => {
      const r = c();
      return !((e.effect || e.placeholderSrc) && !e.visibleByDefault) && !e.wrapperClassName && !e.wrapperProps ? r : i(r);
    };
  }
});
export {
  Ae as LazyLoadComponent,
  ze as LazyLoadImage,
  Me as trackWindowScroll
};
